//
// Created by dominik on 8/23/24.
//

#include "bimodalangle.h"
#include "base.h"

BimodalAngle::BimodalAngle(const double delta, const double eta, const double angle1, const double angle2, const double prob, std::mt19937_64 &rng) :
    Motion(delta, eta, rng),
    m_angle1(angle1 * M_PI / 180.0),
    m_angle2(angle2 * M_PI / 180.0),
    m_prob(prob) {};
BimodalAngle::BimodalAngle(std::mt19937_64 &rng) : Motion(rng) {}

void BimodalAngle::initialize() {
    m_prev_pos = draw_position();
};

double BimodalAngle::jump() {
    const double angle = m_uni_dist(m_rng) < m_prob ? m_angle1 : m_angle2;
    const double gamma{2 * M_PI * m_uni_dist(m_rng)};
    m_prev_pos = rotate(m_prev_pos, angle, gamma);

    return omega_q(m_prev_pos);
}
